From b6c03f36147ed00aa419a6d8a34d14151308576d Mon Sep 17 00:00:00 2001
From: David Malcolm <dmalcolm@redhat.com>
Date: Tue, 15 May 2018 14:00:43 -0400
Subject: [PATCH 47/67] Get rid of EMIT_OPTINFO_AT_VECT_LOCATION in favor of 3
 shorter macros

---
 gcc/tree-vect-data-refs.c | 235 +++++++++++++++++----------------
 gcc/tree-vect-loop.c      | 326 +++++++++++++++++++++++-----------------------
 gcc/tree-vect-slp.c       | 139 ++++++++++----------
 gcc/tree-vect-stmts.c     | 205 ++++++++++++++---------------
 gcc/tree-vectorizer.h     |  18 ++-
 5 files changed, 466 insertions(+), 457 deletions(-)

diff --git a/gcc/tree-vect-data-refs.c b/gcc/tree-vect-data-refs.c
index 89f66bc..9978de3 100644
--- a/gcc/tree-vect-data-refs.c
+++ b/gcc/tree-vect-data-refs.c
@@ -73,7 +73,7 @@ vect_lanes_optab_supported_p (const char *name, convert_optab optab,
       if (!int_mode_for_size (bits, limit_p).exists (&array_mode))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	    OPTINFO_VECT_FAILURE
 	      << optinfo_printf ("no array mode for %s["
 				 HOST_WIDE_INT_PRINT_DEC "]",
 				 GET_MODE_NAME (mode), count);
@@ -84,14 +84,14 @@ vect_lanes_optab_supported_p (const char *name, convert_optab optab,
   if (convert_optab_handler (optab, array_mode, mode) == CODE_FOR_nothing)
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << optinfo_printf ("cannot use %s<%s><%s>", name,
 			     GET_MODE_NAME (array_mode), GET_MODE_NAME (mode));
       return false;
     }
 
   if (optinfo_enabled_p ())
-    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+    OPTINFO_VECT_REMARK
       << optinfo_printf ("can use %s<%s><%s>", name,
 			 GET_MODE_NAME (array_mode),
 			 GET_MODE_NAME (mode));
@@ -184,7 +184,7 @@ vect_check_nonzero_value (loop_vec_info loop_vinfo, tree value)
 
   if (optinfo_enabled_p ())
     {
-      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+      OPTINFO_VECT_REMARK
 	<< "need run-time check that "
 	<< slim (value)
 	<< " is nonzero";
@@ -342,7 +342,7 @@ vect_analyze_data_ref_dependence (struct data_dependence_relation *ddr,
 	{
 	  if (optinfo_enabled_p ())
 	    {
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	      OPTINFO_VECT_FAILURE
 		<< ("versioning for alias not supported for: "
 		    "can't determine dependence between ")
 		<< slim (DR_REF (dra))
@@ -354,7 +354,7 @@ vect_analyze_data_ref_dependence (struct data_dependence_relation *ddr,
 
       if (optinfo_enabled_p ())
 	{
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	  OPTINFO_VECT_FAILURE
 	    << ("versioning for alias required: "
 		"can't determine dependence between ")
 	    << slim (DR_REF (dra))
@@ -384,7 +384,7 @@ vect_analyze_data_ref_dependence (struct data_dependence_relation *ddr,
 	{
 	  if (optinfo_enabled_p ())
 	    {
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	      OPTINFO_VECT_FAILURE
 		<< ("versioning for alias not supported for: "
 		    "bad dist vector for ")
 		<< slim (DR_REF (dra))
@@ -396,7 +396,7 @@ vect_analyze_data_ref_dependence (struct data_dependence_relation *ddr,
 
       if (optinfo_enabled_p ())
         {
-          EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+          OPTINFO_VECT_FAILURE
 	    << ("versioning for alias required: "
 		"bad dist vector for ")
 	    << slim (DR_REF (dra))
@@ -419,14 +419,14 @@ vect_analyze_data_ref_dependence (struct data_dependence_relation *ddr,
       int dist = dist_v[loop_depth];
 
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	OPTINFO_VECT_REMARK
 	  << optinfo_printf ("dependence distance  = %d", dist);
 
       if (dist == 0)
 	{
 	  if (optinfo_enabled_p ())
 	    {
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	      OPTINFO_VECT_REMARK
 		<< "dependence distance == 0 between "
 		<< slim (DR_REF (dra))
 		<< " and "
@@ -454,7 +454,7 @@ vect_analyze_data_ref_dependence (struct data_dependence_relation *ddr,
 	  if (!vect_preserves_scalar_order_p (DR_STMT (dra), DR_STMT (drb)))
 	    {
 	      if (optinfo_enabled_p ())
-		EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		OPTINFO_VECT_FAILURE
 		  << "READ_WRITE dependence in interleaving";
 	      return true;
 	    }
@@ -467,7 +467,7 @@ vect_analyze_data_ref_dependence (struct data_dependence_relation *ddr,
 	      else if (integer_zerop (indicator))
 		{
 		  if (optinfo_enabled_p ())
-		    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		    OPTINFO_VECT_FAILURE
 		      << "access also has a zero step";
 		  return true;
 		}
@@ -481,7 +481,7 @@ vect_analyze_data_ref_dependence (struct data_dependence_relation *ddr,
 	     reversed (to make distance vector positive), and the actual
 	     distance is negative.  */
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	    OPTINFO_VECT_FAILURE
 	      << "dependence distance negative";
 	  /* Record a negative dependence distance to later limit the
 	     amount of stmt copying / unrolling we can perform.
@@ -500,7 +500,7 @@ vect_analyze_data_ref_dependence (struct data_dependence_relation *ddr,
 	     vectorization factor.  */
 	  *max_vf = abs (dist);
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	    OPTINFO_VECT_REMARK
 	      << optinfo_printf ("adjusting maximal vectorization factor to %i",
 				 *max_vf);
 	}
@@ -510,14 +510,14 @@ vect_analyze_data_ref_dependence (struct data_dependence_relation *ddr,
 	  /* Dependence distance does not create dependence, as far as
 	     vectorization is concerned, in this case.  */
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	    OPTINFO_VECT_REMARK
 	      << optinfo_printf ("dependence distance >= VF");
 	  continue;
 	}
 
       if (optinfo_enabled_p ())
 	{
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	  OPTINFO_VECT_FAILURE
 	    << ("not vectorized, possible dependence "
 		"between data-refs ")
 	    << slim (DR_REF (dra))
@@ -609,7 +609,7 @@ vect_slp_analyze_data_ref_dependence (struct data_dependence_relation *ddr)
     {
       if  (optinfo_enabled_p ())
 	{
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	  OPTINFO_VECT_FAILURE
 	    << "can't determine dependence between "
 	    << slim (DR_REF (dra))
 	    << " and "
@@ -618,7 +618,7 @@ vect_slp_analyze_data_ref_dependence (struct data_dependence_relation *ddr)
     }
   else if (optinfo_enabled_p ())
     {
-      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+      OPTINFO_VECT_REMARK
 	<< "determined dependence between "
 	<< slim (DR_REF (dra))
 	<< " and "
@@ -770,7 +770,7 @@ vect_record_base_alignment (vec_info *vinfo, gimple *stmt,
       entry = drb;
       if (optinfo_enabled_p ())
 	{
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	  OPTINFO_VECT_REMARK
 	    << "recording new base alignment for "
 	    << slim (drb->base_address)
 	    << "\n"
@@ -849,7 +849,7 @@ vect_compute_data_ref_alignment (struct data_reference *dr)
   tree vectype = STMT_VINFO_VECTYPE (stmt_info);
 
   if (optinfo_enabled_p ())
-    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+    OPTINFO_VECT_REMARK
       << "vect_compute_data_ref_alignment:";
 
   if (loop_vinfo)
@@ -886,10 +886,10 @@ vect_compute_data_ref_alignment (struct data_reference *dr)
       if (optinfo_enabled_p ())
 	{
 	  if (step_preserves_misalignment_p)
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+	    OPTINFO_VECT_REMARK << optinfo_printf (
 			     "inner step divides the vector alignment.\n");
 	  else
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
+	    OPTINFO_VECT_FAILURE << (
 			     "inner step doesn't divide the vector"
 			     " alignment.\n");
 	}
@@ -906,7 +906,7 @@ vect_compute_data_ref_alignment (struct data_reference *dr)
 	= multiple_p (DR_STEP_ALIGNMENT (dr) * vf, vector_alignment);
 
       if (!step_preserves_misalignment_p && optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
+	OPTINFO_VECT_FAILURE << (
 			 "step doesn't divide the vector alignment.\n");
     }
 
@@ -930,7 +930,7 @@ vect_compute_data_ref_alignment (struct data_reference *dr)
     {
       if (optinfo_enabled_p ())
 	{
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
+	  OPTINFO_VECT_FAILURE << (
 	                   "Unknown alignment for access: ");
 	  dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM, ref);
 	  dump_printf (MSG_MISSED_OPTIMIZATION, "\n");
@@ -948,7 +948,7 @@ vect_compute_data_ref_alignment (struct data_reference *dr)
 	{
 	  if (optinfo_enabled_p ())
 	    {
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+	      OPTINFO_VECT_REMARK << optinfo_printf (
 	                       "can't force alignment of ref: ");
 	      dump_generic_expr (MSG_NOTE, TDF_SLIM, ref);
 	      dump_printf (MSG_NOTE, "\n");
@@ -961,7 +961,7 @@ vect_compute_data_ref_alignment (struct data_reference *dr)
 	 the analysis phase, before deciding to vectorize the loop.  */
       if (optinfo_enabled_p ())
         {
-          EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf ( "force alignment of ");
+          OPTINFO_VECT_REMARK << optinfo_printf ( "force alignment of ");
           dump_generic_expr (MSG_NOTE, TDF_SLIM, ref);
           dump_printf (MSG_NOTE, "\n");
         }
@@ -986,7 +986,7 @@ vect_compute_data_ref_alignment (struct data_reference *dr)
 			   &const_misalignment))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << "Non-constant misalignment for access: "
 	  << slim (ref);
       return true;
@@ -995,7 +995,7 @@ vect_compute_data_ref_alignment (struct data_reference *dr)
   SET_DR_MISALIGNMENT (dr, const_misalignment);
 
   if (optinfo_enabled_p ())
-    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+    OPTINFO_VECT_FAILURE
       << optinfo_printf ("misalign = %d bytes of ref ", DR_MISALIGNMENT (dr))
       << slim (ref);
 
@@ -1061,7 +1061,7 @@ vect_update_misalignment_for_peel (struct data_reference *dr,
     }
 
   if (optinfo_enabled_p ())
-    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf ( "Setting misalignment " \
+    OPTINFO_VECT_REMARK << optinfo_printf ( "Setting misalignment " \
 		     "to unknown (-1).\n");
   SET_DR_MISALIGNMENT (dr, DR_MISALIGNMENT_UNKNOWN);
 }
@@ -1081,10 +1081,10 @@ verify_data_ref_alignment (data_reference_p dr)
       if (optinfo_enabled_p ())
 	{
 	  if (DR_IS_READ (dr))
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
+	    OPTINFO_VECT_FAILURE << (
 			     "not vectorized: unsupported unaligned load.");
 	  else
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
+	    OPTINFO_VECT_FAILURE << (
 			     "not vectorized: unsupported unaligned "
 			     "store.");
 
@@ -1096,7 +1096,7 @@ verify_data_ref_alignment (data_reference_p dr)
     }
 
   if (supportable_dr_alignment != dr_aligned && optinfo_enabled_p ())
-    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+    OPTINFO_VECT_REMARK << optinfo_printf (
 		     "Vectorizing an unaligned access.\n");
 
   return true;
@@ -1193,7 +1193,7 @@ vector_alignment_reachable_p (struct data_reference *dr)
 		int_cst_value (TYPE_SIZE_UNIT (TREE_TYPE (vectype)));
       if (optinfo_enabled_p ())
 	{
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+	  OPTINFO_VECT_REMARK << optinfo_printf (
 	                   "data size =" HOST_WIDE_INT_PRINT_DEC, elmsize);
 	  dump_printf (MSG_NOTE,
 	               ". misalignment = %d.\n", DR_MISALIGNMENT (dr));
@@ -1201,7 +1201,7 @@ vector_alignment_reachable_p (struct data_reference *dr)
       if (DR_MISALIGNMENT (dr) % elmsize)
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
+	    OPTINFO_VECT_FAILURE << (
 	                     "data size does not divide the misalignment.\n");
 	  return false;
 	}
@@ -1212,7 +1212,7 @@ vector_alignment_reachable_p (struct data_reference *dr)
       tree type = TREE_TYPE (DR_REF (dr));
       bool is_packed = not_size_aligned (DR_REF (dr));
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << optinfo_printf ("Unknown misalignment, %snaturally aligned\n",
 			     is_packed ? "not " : "");
       return targetm.vectorize.vector_alignment_reachable (type, is_packed);
@@ -1247,7 +1247,7 @@ vect_get_data_access_cost (struct data_reference *dr,
     vect_get_store_cost (dr, ncopies, inside_cost, body_cost_vec);
 
   if (optinfo_enabled_p ())
-    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+    OPTINFO_VECT_REMARK << optinfo_printf (
                      "vect_get_data_access_cost: inside_cost = %d, "
                      "outside_cost = %d.\n", *inside_cost, *outside_cost);
 }
@@ -1802,7 +1802,7 @@ vect_enhance_data_refs_alignment (loop_vec_info loop_vinfo)
           if (!aligned_access_p (dr))
             {
               if (optinfo_enabled_p ())
-                EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
+                OPTINFO_VECT_FAILURE << (
                                  "vector alignment may not be reachable\n");
               break;
             }
@@ -1996,7 +1996,7 @@ vect_enhance_data_refs_alignment (loop_vec_info loop_vinfo)
 	    npeel /= GROUP_SIZE (stmt_info);
 
           if (optinfo_enabled_p ())
-            EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+            OPTINFO_VECT_REMARK << optinfo_printf (
                              "Try peeling by %d\n", npeel);
         }
 
@@ -2031,7 +2031,7 @@ vect_enhance_data_refs_alignment (loop_vec_info loop_vinfo)
                 {
                   do_peeling = false;
                   if (optinfo_enabled_p ())
-                    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+                    OPTINFO_VECT_REMARK << optinfo_printf (
                         "Disable peeling, max peels reached: %d\n", max_peel);
                 }
             }
@@ -2082,9 +2082,9 @@ vect_enhance_data_refs_alignment (loop_vec_info loop_vinfo)
 	  SET_DR_MISALIGNMENT (dr0, 0);
 	  if (optinfo_enabled_p ())
             {
-              EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+              OPTINFO_VECT_REMARK << optinfo_printf (
                                "Alignment of access forced using peeling.\n");
-              EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+              OPTINFO_VECT_REMARK << optinfo_printf (
                                "Peeling for alignment will be applied.\n");
             }
 
@@ -2206,12 +2206,12 @@ vect_enhance_data_refs_alignment (loop_vec_info loop_vinfo)
           dr = STMT_VINFO_DATA_REF (stmt_info);
 	  SET_DR_MISALIGNMENT (dr, 0);
 	  if (optinfo_enabled_p ())
-            EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+            OPTINFO_VECT_REMARK << optinfo_printf (
                              "Alignment of access forced using versioning.\n");
         }
 
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+        OPTINFO_VECT_REMARK << optinfo_printf (
                          "Versioning for alignment will be applied.\n");
 
       /* Peeling and versioning can't be done together at this time.  */
@@ -2275,7 +2275,7 @@ vect_find_same_alignment_drs (struct data_dependence_relation *ddr)
   STMT_VINFO_SAME_ALIGN_REFS (stmtinfo_b).safe_push (dra);
   if (optinfo_enabled_p ())
     {
-      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+      OPTINFO_VECT_REMARK << optinfo_printf (
 		       "accesses have the same alignment: ");
       dump_generic_expr (MSG_NOTE, TDF_SLIM, DR_REF (dra));
       dump_printf (MSG_NOTE,  " and ");
@@ -2321,7 +2321,7 @@ vect_analyze_data_refs_alignment (loop_vec_info vinfo)
 	    continue;
 
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	    OPTINFO_VECT_FAILURE
 	      << ("not vectorized: can't calculate alignment "
 		  "for data ref");
 
@@ -2355,7 +2355,7 @@ vect_slp_analyze_and_verify_node_alignment (slp_tree node)
       || ! verify_data_ref_alignment (dr))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << ("not vectorized: bad data alignment in basic "
 	      "block");
       return false;
@@ -2426,7 +2426,7 @@ vect_analyze_group_access_1 (struct data_reference *dr)
 	{
 	  if (optinfo_enabled_p ())
 	    {
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	      OPTINFO_VECT_REMARK
 		<< "Step "
 		<< slim (step)
 		<< " is not a multiple of the element size for "
@@ -2456,7 +2456,7 @@ vect_analyze_group_access_1 (struct data_reference *dr)
 	  GROUP_GAP (stmt_info) = groupsize - 1;
 	  if (optinfo_enabled_p ())
 	    {
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	      OPTINFO_VECT_REMARK
 		<< "Detected single element interleaving "
 		<< slim (DR_REF (dr))
 		<< " step "
@@ -2468,9 +2468,9 @@ vect_analyze_group_access_1 (struct data_reference *dr)
 
       if (optinfo_enabled_p ())
         {
- 	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
-	                   "not consecutive access ");
-	  dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM, stmt, 0);
+ 	  OPTINFO_VECT_FAILURE
+	    << "not consecutive access "
+	    << stmt;
         }
 
       if (bb_vinfo)
@@ -2480,7 +2480,7 @@ vect_analyze_group_access_1 (struct data_reference *dr)
           return true;
         }
 
-      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+      OPTINFO_VECT_REMARK
 	<< "using strided accesses";
       STMT_VINFO_STRIDED_P (stmt_info) = true;
       return true;
@@ -2510,13 +2510,13 @@ vect_analyze_group_access_1 (struct data_reference *dr)
               if (DR_IS_WRITE (data_ref))
                 {
                   if (optinfo_enabled_p ())
-                    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+                    OPTINFO_VECT_FAILURE
 		      << "Two store stmts share the same dr";
                   return false;
                 }
 
 	      if (optinfo_enabled_p ())
-		EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		OPTINFO_VECT_FAILURE
 		  << "Two or more load stmts share the same dr";
 
               /* For load use the same data-ref load.  */
@@ -2544,7 +2544,7 @@ vect_analyze_group_access_1 (struct data_reference *dr)
 	      if (DR_IS_WRITE (data_ref))
 		{
                   if (optinfo_enabled_p ())
-                    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+                    OPTINFO_VECT_FAILURE
 		      << "interleaved store with gaps";
 		  return false;
 		}
@@ -2572,7 +2572,7 @@ vect_analyze_group_access_1 (struct data_reference *dr)
       if (groupsize > 4096)
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
+	    OPTINFO_VECT_FAILURE << (
 			     "group is too large\n");
 	  return false;
 	}
@@ -2583,7 +2583,7 @@ vect_analyze_group_access_1 (struct data_reference *dr)
 	  && !DR_IS_READ (dr))
         {
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
+	    OPTINFO_VECT_FAILURE << (
 			     "interleaved store with gaps\n");
 	  return false;
 	}
@@ -2597,7 +2597,7 @@ vect_analyze_group_access_1 (struct data_reference *dr)
       GROUP_SIZE (vinfo_for_stmt (stmt)) = groupsize;
       if (optinfo_enabled_p ())
 	{
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+	  OPTINFO_VECT_REMARK << optinfo_printf (
 			   "Detected interleaving ");
 	  if (DR_IS_READ (dr))
 	    dump_printf (MSG_NOTE, "load ");
@@ -2607,7 +2607,7 @@ vect_analyze_group_access_1 (struct data_reference *dr)
 		       (unsigned)groupsize);
 	  dump_gimple_stmt (MSG_NOTE, TDF_SLIM, stmt, 0);
 	  if (GROUP_GAP (vinfo_for_stmt (stmt)) != 0)
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+	    OPTINFO_VECT_REMARK << optinfo_printf (
 			     "There is a gap of %u elements after the group\n",
 			     GROUP_GAP (vinfo_for_stmt (stmt)));
 	}
@@ -2675,7 +2675,7 @@ vect_analyze_data_ref_access (struct data_reference *dr)
   if (loop_vinfo && !step)
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
+	OPTINFO_VECT_FAILURE << (
 	                 "bad data-ref access in loop\n");
       return false;
     }
@@ -2692,7 +2692,7 @@ vect_analyze_data_ref_access (struct data_reference *dr)
       if (loop->safelen < 2)
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+	    OPTINFO_VECT_REMARK << optinfo_printf (
 			     "zero step in inner loop of nest\n");
 	  return false;
 	}
@@ -2709,7 +2709,7 @@ vect_analyze_data_ref_access (struct data_reference *dr)
       if (integer_zerop (step))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+	    OPTINFO_VECT_REMARK << optinfo_printf (
 	                     "zero step in outer loop.\n");
 	  return DR_IS_READ (dr);
 	}
@@ -2732,7 +2732,7 @@ vect_analyze_data_ref_access (struct data_reference *dr)
   if (loop && nested_in_vect_loop_p (loop, stmt))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+	OPTINFO_VECT_REMARK << optinfo_printf (
 	                 "grouped access in outer loop.\n");
       return false;
     }
@@ -2997,7 +2997,7 @@ vect_analyze_data_ref_accesses (vec_info *vinfo)
 
 	  if (optinfo_enabled_p ())
 	    {
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+	      OPTINFO_VECT_REMARK << optinfo_printf (
 			       "Detected interleaving ");
 	      if (DR_IS_READ (dra))
 		dump_printf (MSG_NOTE, "load ");
@@ -3026,7 +3026,7 @@ vect_analyze_data_ref_accesses (vec_info *vinfo)
         && !vect_analyze_data_ref_access (dr))
       {
 	if (optinfo_enabled_p ())
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
+	  OPTINFO_VECT_FAILURE << (
 	                   "not vectorized: complicated access pattern.\n");
 
         if (is_a <bb_vec_info> (vinfo))
@@ -3180,7 +3180,7 @@ dependence_distance_ge_vf (data_dependence_relation *ddr,
 
   if (optinfo_enabled_p ())
     {
-      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+      OPTINFO_VECT_REMARK << optinfo_printf (
 		       "dependence distance between ");
       dump_generic_expr (MSG_NOTE, TDF_SLIM, DR_REF (DDR_A (ddr)));
       dump_printf (MSG_NOTE,  " and ");
@@ -3222,7 +3222,7 @@ vect_check_lower_bound (loop_vec_info loop_vinfo, tree expr, bool unsigned_p,
 	    lower_bounds[i].min_value = min_value;
 	    if (optinfo_enabled_p ())
 	      {
-		EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+		OPTINFO_VECT_REMARK << optinfo_printf (
 				 "updating run-time check to ");
 		dump_lower_bound (MSG_NOTE, lower_bounds[i]);
 		dump_printf (MSG_NOTE, "\n");
@@ -3234,7 +3234,7 @@ vect_check_lower_bound (loop_vec_info loop_vinfo, tree expr, bool unsigned_p,
   vec_lower_bound lower_bound (expr, unsigned_p, min_value);
   if (optinfo_enabled_p ())
     {
-      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf ( "need a run-time check that ");
+      OPTINFO_VECT_REMARK << optinfo_printf ( "need a run-time check that ");
       dump_lower_bound (MSG_NOTE, lower_bound);
       dump_printf (MSG_NOTE, "\n");
     }
@@ -3366,7 +3366,7 @@ vect_prune_runtime_alias_test_list (loop_vec_info loop_vinfo)
 	    {
 	      if (optinfo_enabled_p ())
 		{
-		  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf ( "checking that ");
+		  OPTINFO_VECT_REMARK << optinfo_printf ( "checking that ");
 		  dump_generic_expr (MSG_NOTE, TDF_SLIM, new_pair.first);
 		  dump_printf (MSG_NOTE, " and ");
 		  dump_generic_expr (MSG_NOTE, TDF_SLIM, new_pair.second);
@@ -3391,7 +3391,7 @@ vect_prune_runtime_alias_test_list (loop_vec_info loop_vinfo)
 	{
 	  if (optinfo_enabled_p ())
 	    {
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+	      OPTINFO_VECT_REMARK << optinfo_printf (
 			       "no need for alias check between ");
 	      dump_generic_expr (MSG_NOTE, TDF_SLIM, DR_REF (dr_a));
 	      dump_printf (MSG_NOTE, " and ");
@@ -3414,7 +3414,7 @@ vect_prune_runtime_alias_test_list (loop_vec_info loop_vinfo)
 	  bool unsigned_p = dr_known_forward_stride_p (dr_a);
 	  if (optinfo_enabled_p ())
 	    {
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf ( "no alias between ");
+	      OPTINFO_VECT_REMARK << optinfo_printf ( "no alias between ");
 	      dump_generic_expr (MSG_NOTE, TDF_SLIM, DR_REF (dr_a));
 	      dump_printf (MSG_NOTE, " and ");
 	      dump_generic_expr (MSG_NOTE, TDF_SLIM, DR_REF (dr_b));
@@ -3490,7 +3490,7 @@ vect_prune_runtime_alias_test_list (loop_vec_info loop_vinfo)
 					     access_size_b);
 	  if (res >= 0 && optinfo_enabled_p ())
 	    {
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+	      OPTINFO_VECT_REMARK << optinfo_printf (
 			       "can tell at compile time that ");
 	      dump_generic_expr (MSG_NOTE, TDF_SLIM, DR_REF (dr_a));
 	      dump_printf (MSG_NOTE, " and ");
@@ -3507,7 +3507,7 @@ vect_prune_runtime_alias_test_list (loop_vec_info loop_vinfo)
 	  if (res == 1)
 	    {
 	      if (optinfo_enabled_p ())
-		EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+		OPTINFO_VECT_REMARK << optinfo_printf (
 				 "not vectorized: compilation time alias.\n");
 	      return false;
 	    }
@@ -3529,7 +3529,7 @@ vect_prune_runtime_alias_test_list (loop_vec_info loop_vinfo)
   unsigned int count = (comp_alias_ddrs.length ()
 			+ check_unequal_addrs.length ());
 
-  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+  OPTINFO_VECT_REMARK << optinfo_printf (
 		   "improved number of alias checks from %d to %d\n",
 		   may_alias_ddrs.length (), count);
   if ((int) count > PARAM_VALUE (PARAM_VECT_MAX_VERSION_FOR_ALIAS_CHECKS))
@@ -3537,7 +3537,7 @@ vect_prune_runtime_alias_test_list (loop_vec_info loop_vinfo)
       if (optinfo_enabled_p ())
 	// FIXME: would be nice to have special highlighting for
 	// command-line options (e.g. params)
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << optinfo_printf ("number of versioning for alias "
 			     "run-time tests exceeds %d "
 			     "(--param vect-max-version-for-alias-checks)",
@@ -3938,7 +3938,7 @@ again:
       if (!dr || !DR_REF (dr))
         {
           if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
+	    OPTINFO_VECT_FAILURE << (
 	                     "not vectorized: unhandled data-ref\n");
           return false;
         }
@@ -4059,7 +4059,7 @@ again:
 	    {
 	      if (optinfo_enabled_p ())
 		{
-		  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		  OPTINFO_VECT_FAILURE
 		    << ("not vectorized: data ref analysis "
 			"failed ")
 		    << stmt;
@@ -4075,7 +4075,7 @@ again:
       if (TREE_CODE (DR_BASE_ADDRESS (dr)) == INTEGER_CST)
         {
           if (optinfo_enabled_p ())
-            EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
+            OPTINFO_VECT_FAILURE << (
                              "not vectorized: base addr of dr is a "
                              "constant\n");
 
@@ -4091,7 +4091,7 @@ again:
         {
           if (optinfo_enabled_p ())
             {
-              EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+              OPTINFO_VECT_FAILURE
 		<< "not vectorized: volatile type "
 		<< stmt;
             }
@@ -4106,7 +4106,7 @@ again:
         {
           if (optinfo_enabled_p ())
             {
-              EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+              OPTINFO_VECT_FAILURE
 		<< "not vectorized: statement can throw an exception "
 		<< stmt;
             }
@@ -4124,7 +4124,7 @@ again:
 	{
           if (optinfo_enabled_p ())
             {
-              EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+              OPTINFO_VECT_FAILURE
 		<< ("not vectorized: statement is bitfield "
 		    "access ")
 		<< stmt;
@@ -4149,7 +4149,7 @@ again:
 	{
 	  if (optinfo_enabled_p ())
 	    {
-              EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+              OPTINFO_VECT_FAILURE
 		<< "not vectorized: dr in a call "
 		<< stmt;
 	    }
@@ -4183,7 +4183,7 @@ again:
 
 	  if (optinfo_enabled_p ())
 	    {
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	      OPTINFO_VECT_REMARK
 		<< "analyze in outer loop: "
 		<< slim (init_ref);
 	    }
@@ -4195,7 +4195,7 @@ again:
 
           if (optinfo_enabled_p ())
 	    {
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+	      OPTINFO_VECT_REMARK << optinfo_printf (
                                "\touter base_address: ");
 	      dump_generic_expr (MSG_NOTE, TDF_SLIM,
                                  STMT_VINFO_DR_BASE_ADDRESS (stmt_info));
@@ -4224,7 +4224,7 @@ again:
         {
           if (optinfo_enabled_p ())
             {
-              EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+              OPTINFO_VECT_FAILURE
 		<< ("not vectorized: more than one data ref "
 		    "in stmt: ")
 		<< stmt;
@@ -4252,7 +4252,7 @@ again:
 	{
           if (optinfo_enabled_p ())
             {
-              EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+              OPTINFO_VECT_FAILURE
 		<< ("not vectorized: base object not addressable "
 		    "for stmt: ")
 		<< stmt;
@@ -4275,7 +4275,7 @@ again:
         {
           if (optinfo_enabled_p ())
             {
-              EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+              OPTINFO_VECT_FAILURE
 		<< "not vectorized: no vectype for stmt: "
 		<< stmt
 		<< " scalar_type: "
@@ -4302,7 +4302,7 @@ again:
 	{
 	  if (optinfo_enabled_p ())
 	    {
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	      OPTINFO_VECT_REMARK
 		<< "got vectype for stmt: "
 		<< stmt
 		<< slim (STMT_VINFO_VECTYPE (stmt_info));
@@ -4325,7 +4325,7 @@ again:
 	      free_data_ref (dr);
 	      if (optinfo_enabled_p ())
 		{
-		  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		  OPTINFO_VECT_FAILURE
 		    << ((gatherscatter == GATHER) ?
 			"not vectorized: not suitable for gather "
 			"load " :
@@ -4348,7 +4348,7 @@ again:
 	    {
 	      if (optinfo_enabled_p ())
 		{
-		  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		  OPTINFO_VECT_FAILURE
 		    << ("not vectorized: not suitable for strided "
 			"load ")
 		    << stmt;
@@ -4580,7 +4580,7 @@ vect_create_addr_base_for_vector_ref (gimple *stmt,
 
   if (optinfo_enabled_p ())
     {
-      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf ( "created ");
+      OPTINFO_VECT_REMARK << optinfo_printf ( "created ");
       dump_generic_expr (MSG_NOTE, TDF_SLIM, addr_base);
       dump_printf (MSG_NOTE, "\n");
     }
@@ -4708,7 +4708,7 @@ vect_create_data_ref_ptr (gimple *stmt, tree aggr_type, struct loop *at_loop,
   if (optinfo_enabled_p ())
     {
       tree dr_base_type = TREE_TYPE (DR_BASE_OBJECT (dr));
-      pending_optinfo po = EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+      pending_optinfo po = OPTINFO_VECT_REMARK
 	<< optinfo_printf ("create %s-pointer variable to type: ",
 			   get_tree_code_name (TREE_CODE (aggr_type)))
 	<< slim (aggr_type);
@@ -5035,7 +5035,7 @@ vect_grouped_store_supported (tree vectype, unsigned HOST_WIDE_INT count)
   if (count != 3 && exact_log2 (count) == -1)
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << ("the size of the group of accesses"
 	      " is not a power of 2 or not equal to 3");
       return false;
@@ -5054,7 +5054,7 @@ vect_grouped_store_supported (tree vectype, unsigned HOST_WIDE_INT count)
 	  if (!GET_MODE_NUNITS (mode).is_constant (&nelt))
 	    {
 	      if (optinfo_enabled_p ())
-		EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		OPTINFO_VECT_FAILURE
 		  << ("cannot handle groups of 3 stores for"
 		      " variable-length vectors");
 	      return false;
